(* Time-stamp: <modified the 23/05/2024 (at 11:38) by Erwan Jahier> *)

open Types
(******************************************************************************)
(* Parser *)

let rec (get_ci_rel_size : cmd list -> float option) = function
  | [] -> None
  | cmd::t ->
    match Str.split (Str.regexp "=") cmd with
    | "ci_rel_size"::size::_ -> (try Some (float_of_string size) with _ -> get_ci_rel_size t)
    | "significant_digits"::size::_ -> (try Some (10. ** (-. (float_of_string size))) with _ -> get_ci_rel_size t)
    | _ -> get_ci_rel_size t

let (get_string : Yaml.value -> string) = function
  | `String s -> s
  | _ -> failwith "a (shell command) string is expected"

let (get_cmd : Yaml.value -> cmd list) = function
  | `A vl ->  List.map get_string vl
  | _ -> failwith "a (shell commands) sequence is expected (as phase values)"

let (get_phase : Yaml.value -> phase) = function
  | `O [phase_name, phase_def] ->
    let cmds = get_cmd phase_def in
    phase_name, cmds, get_ci_rel_size cmds

  | _ -> failwith "a (phase) mapping is expected (as phase definitions)"

let (get_job : string * Yaml.value -> job) =
  fun (job_name, job_def) ->
    match job_def with
    | `A pl -> job_name, List.map get_phase pl
    | _ -> failwith "a (phase) sequence is expected (as job values)"

let (get_jobs : Yaml.value -> job list) =
  function
  | `O jl -> List.map get_job jl
  | _ -> failwith "a (job) mapping is expected (at top-level)"

let (f : string -> job list) =
  fun fn ->
  Yaml_unix.of_file_exn (Fpath.v fn) |> get_jobs

(******************************************************************************)
(* Printer *)

let (phase_to_string : phase -> string) =
  fun (n,d,_ci) ->
  Printf.sprintf "%s:\n     - %s" n (String.concat "\n     - " d)

let (job_to_string : job -> string) =
  fun (n,d) ->
  Printf.sprintf "%s:\n   - %s\n" n
    (String.concat "\n   - " (List.map phase_to_string d))

let (to_string : job list -> string) = fun jobs ->
  String.concat  "\n" (List.map job_to_string jobs)

(******************************************************************************)

let example = "lv6-via-c:
   - copy-files:
     - echo \"once must copy there all necessary files first\"
     - cp $1/$2* .
   - lus2c:
     - basename=$2
     - node=$3
     - echo \"let's compile $basename.lus using $node as main node\"
     - lv6 $basename.lus -n $node -2c
   - c2exe:
     - echo \"let's compile the generated C code ($2.sh is generated by lv6 -2c)\"
     - ./$2.sh
   - run:
     - significant_digits=2
     - ./$2.exec

lv6-via-exec:
   - copy-files:
     - cp $1/$2* .
   - lus2c:
     - echo \"nothing to do\"
   - c2exe:
     - echo \"nothing to do\"
   - run:
     - ci_rel_size=0.1
     - lv6 $basename.lus -n $node -exec
"

let string_to_file_name str =
  let tmpfile, oc = Filename.open_temp_file "run-bench-test" ".yml" in
  Printf.fprintf oc "%s" str;
  close_out oc;
  tmpfile

let _ = (* A small test: parse o print = identity *)
  assert ((example |> string_to_file_name |> f |> to_string) = example)
